

bl_info = {
    "name" : "BrushTextureGallery",
    "author" : "xz-blender", 
    "description" : "",
    "blender" : (4, 2, 0),
    "version" : (1, 3, 2),
    "location" : "N panel > BrushTexGallery when it's in Texture Paint, Vertex Paint or Sculpt mode. Or press shortcut Alt + T(default).",
    "warning" : "",
    "doc_url": "", 
    "tracker_url": "", 
    "category" : "User Interface" 
}


import bpy
import bpy.utils.previews
from bpy.app.handlers import persistent
import os




def string_to_int(value):
    if value.isdigit():
        return int(value)
    return 0


def string_to_icon(value):
    if value in bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items.keys():
        return bpy.types.UILayout.bl_rna.functions["prop"].parameters["icon"].enum_items[value].value
    return string_to_int(value)


addon_keymaps = {}
_icons = None
loadtextures = {'sna_imageslist': [], 'sna_enumlength': 0, 'sna_settexture': False, }
nodetree_vars_93FF1 = {}


def sna_gallery_enum_assets_pre_build_9A1D2_93FF1(AssetPath):
    loadtextures['sna_imageslist'] = []
    for i_7443E in range(len([os.path.join(AssetPath, f) for f in os.listdir(AssetPath) if os.path.isfile(os.path.join(AssetPath, f))])):
        loadtextures['sna_imageslist'].append([os.path.join(AssetPath, f) for f in os.listdir(AssetPath) if os.path.isfile(os.path.join(AssetPath, f))][i_7443E])
    return


nodetree_vars_871F3 = {'sna_gallerylist': [], }
nodetree_vars_0D1DC = {}


def sna_gallery_enum_assets_pre_build_9A1D2_0D1DC(AssetPath):
    loadtextures['sna_imageslist'] = []
    for i_7443E in range(len([os.path.join(AssetPath, f) for f in os.listdir(AssetPath) if os.path.isfile(os.path.join(AssetPath, f))])):
        loadtextures['sna_imageslist'].append([os.path.join(AssetPath, f) for f in os.listdir(AssetPath) if os.path.isfile(os.path.join(AssetPath, f))][i_7443E])
    return


nodetree_vars_871F3 = {'sna_gallerylist': [], }


def sna_update_sna_currentpath_B5B83(self, context):
    sna_updated_prop = self.sna_currentpath
    sna_gallery_enum_assets_pre_build_9A1D2_DC8E8(sna_updated_prop)
    sna_setenumfirst_DF5E3(sna_enum_gallery_for_pre_load_images_098CC_871F3(loadtextures['sna_imageslist']))


nodetree_vars_DC8E8 = {}


def sna_gallery_enum_assets_pre_build_9A1D2_DC8E8(AssetPath):
    loadtextures['sna_imageslist'] = []
    for i_7443E in range(len([os.path.join(AssetPath, f) for f in os.listdir(AssetPath) if os.path.isfile(os.path.join(AssetPath, f))])):
        loadtextures['sna_imageslist'].append([os.path.join(AssetPath, f) for f in os.listdir(AssetPath) if os.path.isfile(os.path.join(AssetPath, f))][i_7443E])
    return


nodetree_vars_871F3 = {'sna_gallerylist': [], }
_item_map = dict()


def make_enum_item(_id, name, descr, preview_id, uid):
    lookup = str(_id)+"\0"+str(name)+"\0"+str(descr)+"\0"+str(preview_id)+"\0"+str(uid)
    if not lookup in _item_map:
        _item_map[lookup] = (_id, name, descr, preview_id, uid)
    return _item_map[lookup]


nodetree_vars_871F3 = {'sna_gallerylist': [], }


def sna_enum_gallery_for_pre_load_images_098CC_871F3(galleryImages):
    nodetree_vars_871F3['sna_gallerylist'] = []
    for i_5564D in range(len(galleryImages)):
        if os.path.splitext(galleryImages[i_5564D])[1] == '.png' or os.path.splitext(galleryImages[i_5564D])[1] == '.jpg' or os.path.splitext(galleryImages[i_5564D])[1] == '.psd' or os.path.splitext(galleryImages[i_5564D])[1] == '.tif' or os.path.splitext(galleryImages[i_5564D])[1] == '.exr':
            nodetree_vars_871F3['sna_gallerylist'].append([galleryImages[i_5564D], os.path.basename(galleryImages[i_5564D]), '', load_preview_icon(galleryImages[i_5564D])])
    return nodetree_vars_871F3['sna_gallerylist']


def load_preview_icon(path):
    global _icons
    if not path in _icons:
        if os.path.exists(path):
            _icons.load(path, path, "IMAGE")
        else:
            return 0
    return _icons[path].icon_id


def sna_update_sna_texturesenum_ECAD4(self, context):
    sna_updated_prop = self.sna_texturesenum
    sna_createorsettexture_BC808(sna_updated_prop, True)


def find_user_keyconfig(key):
    km, kmi = addon_keymaps[key]
    for item in bpy.context.window_manager.keyconfigs.user.keymaps[km.name].keymap_items:
        found_item = False
        if kmi.idname == item.idname:
            found_item = True
            for name in dir(kmi.properties):
                if not name in ["bl_rna", "rna_type"] and not name[0] == "_":
                    if name in kmi.properties and name in item.properties and not kmi.properties[name] == item.properties[name]:
                        found_item = False
        if found_item:
            return item
    print(f"Couldn't find keymap item for {key}, using addon keymap instead. This won't be saved across sessions!")
    return kmi


def sna_update_sna_defaultpath_E3964(self, context):
    sna_updated_prop = self.sna_defaultpath
    bpy.context.scene.sna_currentpath = sna_updated_prop


def property_exists(prop_path, glob, loc):
    try:
        eval(prop_path, glob, loc)
        return True
    except:
        return False


def display_collection_id(uid, vars):
    id = f"coll_{uid}"
    for var in vars.keys():
        if var.startswith("i_"):
            id += f"_{var}_{vars[var]}"
    return id


class SNA_UL_display_collection_list_170E5(bpy.types.UIList):

    def draw_item(self, context, layout, data, item_170E5, icon, active_data, active_propname, index_170E5):
        row = layout
        op = layout.operator('sna.settexturefromhistoryoperator_b66de', text=os.path.basename(str(item_170E5.texturename)), icon_value=0, emboss=True, depress=False)
        op.sna_texturepath = item_170E5.texturename

    def filter_items(self, context, data, propname):
        flt_flags = []
        for item in getattr(data, propname):
            if not self.filter_name or self.filter_name.lower() in item.name.lower():
                if True:
                    flt_flags.append(self.bitflag_filter_item)
                else:
                    flt_flags.append(0)
            else:
                flt_flags.append(0)
        return flt_flags, []


@persistent
def load_pre_handler_25DF6(dummy):
    sna_gallery_enum_assets_pre_build_9A1D2_93FF1(bpy.context.scene.sna_currentpath)
    sna_setenumfirst_DF5E3(sna_enum_gallery_for_pre_load_images_098CC_871F3(loadtextures['sna_imageslist']))


class SNA_OT_Refresh_71A30(bpy.types.Operator):
    bl_idname = "sna.refresh_71a30"
    bl_label = "Refresh"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        sna_gallery_enum_assets_pre_build_9A1D2_0D1DC(bpy.context.scene.sna_currentpath)
        sna_setenumfirst_DF5E3(sna_enum_gallery_for_pre_load_images_098CC_871F3(loadtextures['sna_imageslist']))
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_texturesenum_enum_items(self, context):
    enum_items = sna_enum_gallery_for_pre_load_images_098CC_871F3(loadtextures['sna_imageslist'])
    return [make_enum_item(item[0], item[1], item[2], item[3], i) for i, item in enumerate(enum_items)]


def sna_setenumfirst_DF5E3(Input):
    if bool(len(Input)):
        loadtextures['sna_settexture'] = False
        bpy.context.scene.sna_texturesenum = str(Input[0][0])
    loadtextures['sna_enumlength'] = len(Input)
    loadtextures['sna_settexture'] = True


def sna_createorsettexture_BC808(path, addToHistory):
    if loadtextures['sna_settexture']:
        if addToHistory:
            sna_addtohistory_253EE(os.path.basename(path))
        if property_exists("bpy.data.textures[os.path.basename(path)]", globals(), locals()):
            pass
        else:
            path = path
            img_name = os.path.basename(path)
            tex = bpy.data.textures.new(img_name, 'IMAGE')
            img = bpy.data.images.load(filepath=path)
            tex.image = img
            # bpy.context.tool_settings.sculpt.brush.texture = tex
        if 'PAINT_TEXTURE'==bpy.context.mode:
            if bpy.context.scene.sna_setfortexturemask:
                bpy.context.tool_settings.image_paint.brush.mask_texture = bpy.data.textures[os.path.basename(path)]
            else:
                bpy.context.tool_settings.image_paint.brush.texture = bpy.data.textures[os.path.basename(path)]
        else:
            if 'SCULPT'==bpy.context.mode:
                bpy.context.tool_settings.sculpt.brush.texture = bpy.data.textures[os.path.basename(path)]
            else:
                if 'PAINT_VERTEX'==bpy.context.mode:
                    bpy.context.tool_settings.vertex_paint.brush.texture = bpy.data.textures[os.path.basename(path)]


def sna_addtohistory_253EE(texName):
    item_0726D = bpy.context.scene.sna_historycol.add()
    item_0726D.texturename = texName
    bpy.context.scene.sna_historycol.move(int(len(bpy.context.scene.sna_historycol) - 1.0), 0)
    item_A0597 = bpy.context.scene.sna_historycol[0]
    if (len(bpy.context.scene.sna_historycol) > 30):
        if len(bpy.context.scene.sna_historycol) > int(len(bpy.context.scene.sna_historycol) - 1.0):
            bpy.context.scene.sna_historycol.remove(int(len(bpy.context.scene.sna_historycol) - 1.0))


class SNA_OT_Settexturefromhistoryoperator_B66De(bpy.types.Operator):
    bl_idname = "sna.settexturefromhistoryoperator_b66de"
    bl_label = "SetTextureFromHistoryOperator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_texturepath: bpy.props.StringProperty(name='TexturePath', description='', default='', subtype='FILE_PATH', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        loadtextures['sna_settexture'] = True
        sna_createorsettexture_BC808(self.sna_texturepath, False)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Resettextureoperator_72703(bpy.types.Operator):
    bl_idname = "sna.resettextureoperator_72703"
    bl_label = "ResetTextureOperator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_formask: bpy.props.BoolProperty(name='forMask', description='', default=False)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        if 'PAINT_TEXTURE'==bpy.context.mode:
            if self.sna_formask:
                bpy.context.tool_settings.image_paint.brush.mask_texture = None
            else:
                bpy.context.tool_settings.image_paint.brush.texture = None
        else:
            if 'SCULPT'==bpy.context.mode:
                bpy.context.tool_settings.sculpt.brush.texture = None
            else:
                if 'PAINT_VERTEX'==bpy.context.mode:
                    bpy.context.tool_settings.vertex_paint.brush.texture = None
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_PT_TEXTURE_CED45(bpy.types.Panel):
    bl_label = '纹理'
    bl_idname = 'SNA_PT_TEXTURE_CED45'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_category = 'BrushTexGallery'
    bl_order = 0
    bl_ui_units_x=20

    @classmethod
    def poll(cls, context):
        return not ((not (('PAINT_TEXTURE'==bpy.context.mode or 'SCULPT'==bpy.context.mode or 'PAINT_VERTEX'==bpy.context.mode) and bpy.context.preferences.addons[__package__].preferences.sna_showinnpanel)))

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout_function = layout
        sna_function_interface_730A0(layout_function, )


class SNA_OT_Gobackfolderoperator_630B2(bpy.types.Operator):
    bl_idname = "sna.gobackfolderoperator_630b2"
    bl_label = "GoBackFolderOperator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_currentpath = os.path.dirname(bpy.context.scene.sna_currentpath)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_OT_Setcurrentpath_643D5(bpy.types.Operator):
    bl_idname = "sna.setcurrentpath_643d5"
    bl_label = "SetCurrentPath"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}
    sna_path: bpy.props.StringProperty(name='path', description='', default='', subtype='DIR_PATH', maxlen=0)

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not False

    def execute(self, context):
        bpy.context.scene.sna_currentpath = self.sna_path
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


class SNA_AddonPreferences_732C8(bpy.types.AddonPreferences):
    bl_idname = __package__
    sna_defaultpath: bpy.props.StringProperty(name='defaultPath', description='', default='', subtype='DIR_PATH', maxlen=0, update=sna_update_sna_defaultpath_E3964)
    sna_showinnpanel: bpy.props.BoolProperty(name='showInNPanel', description='', default=True)
    sna_showfromshortcut: bpy.props.BoolProperty(name='showFromShortcut', description='', default=True)

    def draw(self, context):
        if not (False):
            layout = self.layout 
            layout.prop(bpy.context.preferences.addons[__package__].preferences, 'sna_defaultpath', text='默认纹理文件夹', icon_value=0, emboss=True)
            layout.prop(bpy.context.preferences.addons[__package__].preferences, 'sna_showinnpanel', text='在纹理绘制模式N面板中显示', icon_value=0, emboss=True)
            layout.prop(bpy.context.preferences.addons[__package__].preferences, 'sna_showfromshortcut', text='展示快捷键', icon_value=0, emboss=True)
            if bpy.context.preferences.addons[__package__].preferences.sna_showfromshortcut:
                layout.prop(find_user_keyconfig('08E89'), 'type', text='快捷键', full_event=True)


@persistent
def load_post_handler_06685(dummy):
    if (bpy.context.preferences.addons[__package__].preferences.sna_defaultpath == ''):
        pass
    else:
        bpy.context.scene.sna_currentpath = bpy.context.preferences.addons[__package__].preferences.sna_defaultpath


class SNA_OT_Openpaneloperator_0944D(bpy.types.Operator):
    bl_idname = "sna.openpaneloperator_0944d"
    bl_label = "OpenPanelOperator"
    bl_description = ""
    bl_options = {"REGISTER", "UNDO"}

    @classmethod
    def poll(cls, context):
        if bpy.app.version >= (3, 0, 0) and True:
            cls.poll_message_set('')
        return not (not (('PAINT_TEXTURE'==bpy.context.mode or 'SCULPT'==bpy.context.mode or 'PAINT_VERTEX'==bpy.context.mode) and bpy.context.preferences.addons[__package__].preferences.sna_showfromshortcut))

    def execute(self, context):
        bpy.ops.wm.call_panel(name="SNA_PT_TEXTURE_6440A", keep_open=True)
        return {"FINISHED"}

    def invoke(self, context, event):
        return self.execute(context)


def sna_function_interface_730A0(layout_function, ):
    row_4BB25 = layout_function.row(heading='', align=False)
    row_4BB25.alert = False
    row_4BB25.enabled = True
    row_4BB25.active = True
    row_4BB25.use_property_split = False
    row_4BB25.use_property_decorate = False
    row_4BB25.scale_x = 1.0
    row_4BB25.scale_y = 1.0
    row_4BB25.alignment = 'Expand'.upper()
    row_4BB25.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    row_4BB25.label(text=((bpy.context.tool_settings.sculpt.brush.texture.name if property_exists("bpy.context.tool_settings.sculpt.brush.texture.name", globals(), locals()) else 'None') if 'SCULPT'==bpy.context.mode else ((bpy.context.tool_settings.vertex_paint.brush.texture.name if property_exists("bpy.context.tool_settings.vertex_paint.brush.texture.name", globals(), locals()) else 'None') if 'PAINT_VERTEX'==bpy.context.mode else ((bpy.context.tool_settings.image_paint.brush.texture.name if property_exists("bpy.context.tool_settings.image_paint.brush.texture.name", globals(), locals()) else 'None') if 'PAINT_TEXTURE'==bpy.context.mode else None))), icon_value=string_to_icon('TEXTURE_DATA'))
    if 'PAINT_TEXTURE'==bpy.context.mode:
        row_4BB25.label(text=(bpy.context.tool_settings.image_paint.brush.mask_texture.name if property_exists("bpy.context.tool_settings.image_paint.brush.mask_texture.name", globals(), locals()) else 'None'), icon_value=string_to_icon('MOD_MASK'))
    box_D424F = layout_function.box()
    box_D424F.alert = False
    box_D424F.enabled = True
    box_D424F.active = True
    box_D424F.use_property_split = False
    box_D424F.use_property_decorate = False
    box_D424F.alignment = 'Expand'.upper()
    box_D424F.scale_x = 1.0
    box_D424F.scale_y = 1.0
    if not True: box_D424F.operator_context = "EXEC_DEFAULT"
    box_D424F.prop(bpy.context.scene, 'sna_currentpath', text='', icon_value=0, emboss=True)
    row_6D9FF = box_D424F.row(heading='', align=False)
    row_6D9FF.alert = False
    row_6D9FF.enabled = True
    row_6D9FF.active = True
    row_6D9FF.use_property_split = False
    row_6D9FF.use_property_decorate = False
    row_6D9FF.scale_x = 1.0
    row_6D9FF.scale_y = 1.0
    row_6D9FF.alignment = 'Expand'.upper()
    row_6D9FF.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    split_76B21 = row_6D9FF.split(factor=0.36000001430511475, align=False)
    split_76B21.alert = False
    split_76B21.enabled = True
    split_76B21.active = True
    split_76B21.use_property_split = False
    split_76B21.use_property_decorate = False
    split_76B21.scale_x = 1.0
    split_76B21.scale_y = 1.0
    split_76B21.alignment = 'Expand'.upper()
    if not True: split_76B21.operator_context = "EXEC_DEFAULT"
    op = split_76B21.operator('sna.gobackfolderoperator_630b2', text='', icon_value=string_to_icon('BACK'), emboss=True, depress=False)
    if 'PAINT_TEXTURE'==bpy.context.mode:
        split_76B21.prop(bpy.context.scene, 'sna_setfortexturemask', text='作为蒙版纹理', icon_value=0, emboss=True)
    grid_1BD5D = box_D424F.grid_flow(columns=2, row_major=True, even_columns=False, even_rows=False, align=False)
    grid_1BD5D.enabled = True
    grid_1BD5D.active = True
    grid_1BD5D.use_property_split = False
    grid_1BD5D.use_property_decorate = False
    grid_1BD5D.alignment = 'Expand'.upper()
    grid_1BD5D.scale_x = 1.0
    grid_1BD5D.scale_y = 1.0
    if not True: grid_1BD5D.operator_context = "EXEC_DEFAULT"
    for i_774EE in range(len([os.path.join(bpy.context.scene.sna_currentpath, f) for f in os.listdir(bpy.context.scene.sna_currentpath)])):
        if os.path.isdir([os.path.join(bpy.context.scene.sna_currentpath, f) for f in os.listdir(bpy.context.scene.sna_currentpath)][i_774EE]):
            op = grid_1BD5D.operator('sna.setcurrentpath_643d5', text=os.path.basename([os.path.join(bpy.context.scene.sna_currentpath, f) for f in os.listdir(bpy.context.scene.sna_currentpath)][i_774EE]), icon_value=0, emboss=True, depress=False)
            op.sna_path = [os.path.join(bpy.context.scene.sna_currentpath, f) for f in os.listdir(bpy.context.scene.sna_currentpath)][i_774EE]
    if bool(loadtextures['sna_enumlength']):
        box_D424F.template_icon_view(bpy.context.scene, 'sna_texturesenum', show_labels=True, scale=5.0, scale_popup=5.0)
    else:
        box_D424F.label(text='没有找到图像文件.', icon_value=0)
    op = box_D424F.operator('sna.refresh_71a30', text='刷新', icon_value=string_to_icon('FILE_REFRESH'), emboss=True, depress=False)
    box_D424F.separator(factor=0.5)
    row_7F682 = box_D424F.row(heading='', align=False)
    row_7F682.alert = False
    row_7F682.enabled = True
    row_7F682.active = True
    row_7F682.use_property_split = False
    row_7F682.use_property_decorate = False
    row_7F682.scale_x = 1.0
    row_7F682.scale_y = 1.0
    row_7F682.alignment = 'Expand'.upper()
    row_7F682.operator_context = "INVOKE_DEFAULT" if True else "EXEC_DEFAULT"
    op = row_7F682.operator('sna.resettextureoperator_72703', text='重置纹理', icon_value=string_to_icon('CANCEL'), emboss=True, depress=False)
    op.sna_formask = False
    if 'PAINT_TEXTURE'==bpy.context.mode:
        op = row_7F682.operator('sna.resettextureoperator_72703', text='重置蒙版纹理', icon_value=string_to_icon('CANCEL'), emboss=True, depress=False)
        op.sna_formask = True


class SNA_PT_TEXTURE_6440A(bpy.types.Panel):
    bl_label = '纹理'
    bl_idname = 'SNA_PT_TEXTURE_6440A'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'WINDOW'
    bl_context = ''
    bl_order = 0
    bl_ui_units_x=20

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout_function = layout
        sna_function_interface_730A0(layout_function, )


def sna_function_interface001_19D7D(layout_function, ):
    coll_id = display_collection_id('170E5', locals())
    layout_function.template_list('SNA_UL_display_collection_list_170E5', coll_id, bpy.context.scene, 'sna_historycol', bpy.context.scene, 'sna_historyindex', rows=0)


class SNA_PT_HISTORY_59D73(bpy.types.Panel):
    bl_label = '历史纪录'
    bl_idname = 'SNA_PT_HISTORY_59D73'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'UI'
    bl_context = ''
    bl_order = 0
    bl_parent_id = 'SNA_PT_TEXTURE_CED45'
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not ((not (('PAINT_TEXTURE'==bpy.context.mode or 'SCULPT'==bpy.context.mode or 'PAINT_VERTEX'==bpy.context.mode) and bpy.context.preferences.addons[__package__].preferences.sna_showinnpanel)))

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout_function = layout
        sna_function_interface001_19D7D(layout_function, )


class SNA_PT_HISTORY_CC0A1(bpy.types.Panel):
    bl_label = '历史记录'
    bl_idname = 'SNA_PT_HISTORY_CC0A1'
    bl_space_type = 'VIEW_3D'
    bl_region_type = 'WINDOW'
    bl_context = ''
    bl_order = 0
    bl_parent_id = 'SNA_PT_TEXTURE_6440A'
    bl_ui_units_x=0

    @classmethod
    def poll(cls, context):
        return not (False)

    def draw_header(self, context):
        layout = self.layout

    def draw(self, context):
        layout = self.layout
        layout_function = layout
        sna_function_interface001_19D7D(layout_function, )


class SNA_GROUP_sna_historygroup(bpy.types.PropertyGroup):
    texturename: bpy.props.StringProperty(name='纹理名称', description='', default='', subtype='NONE', maxlen=0)


def register():
    global _icons
    _icons = bpy.utils.previews.new()
    bpy.utils.register_class(SNA_GROUP_sna_historygroup)
    bpy.types.Scene.sna_currentpath = bpy.props.StringProperty(name='当前路径', description='', default='', subtype='DIR_PATH', maxlen=0, update=sna_update_sna_currentpath_B5B83)
    bpy.types.Scene.sna_texturesenum = bpy.props.EnumProperty(name='TexturesEnum', description='', items=sna_texturesenum_enum_items, update=sna_update_sna_texturesenum_ECAD4)
    bpy.types.Scene.sna_setfortexturemask = bpy.props.BoolProperty(name='SetForTextureMask', description='', default=False)
    bpy.types.Scene.sna_historycol = bpy.props.CollectionProperty(name='HistoryCol', description='', type=SNA_GROUP_sna_historygroup)
    bpy.types.Scene.sna_historyindex = bpy.props.IntProperty(name='HistoryIndex', description='', default=0, subtype='NONE')
    bpy.app.handlers.load_pre.append(load_pre_handler_25DF6)
    bpy.utils.register_class(SNA_OT_Refresh_71A30)
    bpy.utils.register_class(SNA_OT_Settexturefromhistoryoperator_B66De)
    bpy.utils.register_class(SNA_OT_Resettextureoperator_72703)
    bpy.utils.register_class(SNA_PT_TEXTURE_CED45)
    bpy.utils.register_class(SNA_OT_Gobackfolderoperator_630B2)
    bpy.utils.register_class(SNA_OT_Setcurrentpath_643D5)
    bpy.utils.register_class(SNA_AddonPreferences_732C8)
    bpy.app.handlers.load_post.append(load_post_handler_06685)
    bpy.utils.register_class(SNA_OT_Openpaneloperator_0944D)
    bpy.utils.register_class(SNA_PT_TEXTURE_6440A)
    bpy.utils.register_class(SNA_UL_display_collection_list_170E5)
    bpy.utils.register_class(SNA_PT_HISTORY_59D73)
    bpy.utils.register_class(SNA_PT_HISTORY_CC0A1)
    kc = bpy.context.window_manager.keyconfigs.addon
    km = kc.keymaps.new(name='3D View', space_type='VIEW_3D')
    kmi = km.keymap_items.new('sna.openpaneloperator_0944d', 'T', 'PRESS',
        ctrl=False, alt=True, shift=False, repeat=False)
    addon_keymaps['08E89'] = (km, kmi)


def unregister():
    global _icons
    bpy.utils.previews.remove(_icons)
    wm = bpy.context.window_manager
    kc = wm.keyconfigs.addon
    for km, kmi in addon_keymaps.values():
        km.keymap_items.remove(kmi)
    addon_keymaps.clear()
    del bpy.types.Scene.sna_historyindex
    del bpy.types.Scene.sna_historycol
    del bpy.types.Scene.sna_setfortexturemask
    del bpy.types.Scene.sna_texturesenum
    del bpy.types.Scene.sna_currentpath
    bpy.utils.unregister_class(SNA_GROUP_sna_historygroup)
    bpy.app.handlers.load_pre.remove(load_pre_handler_25DF6)
    bpy.utils.unregister_class(SNA_OT_Refresh_71A30)
    bpy.utils.unregister_class(SNA_OT_Settexturefromhistoryoperator_B66De)
    bpy.utils.unregister_class(SNA_OT_Resettextureoperator_72703)
    bpy.utils.unregister_class(SNA_PT_TEXTURE_CED45)
    bpy.utils.unregister_class(SNA_OT_Gobackfolderoperator_630B2)
    bpy.utils.unregister_class(SNA_OT_Setcurrentpath_643D5)
    bpy.utils.unregister_class(SNA_AddonPreferences_732C8)
    bpy.app.handlers.load_post.remove(load_post_handler_06685)
    bpy.utils.unregister_class(SNA_OT_Openpaneloperator_0944D)
    bpy.utils.unregister_class(SNA_PT_TEXTURE_6440A)
    bpy.utils.unregister_class(SNA_UL_display_collection_list_170E5)
    bpy.utils.unregister_class(SNA_PT_HISTORY_59D73)
    bpy.utils.unregister_class(SNA_PT_HISTORY_CC0A1)
